import { FORMS } from  '../forms'
import {
    ActionFormData,
    ActionFormResponse,
    MessageFormData,
    ModalFormData
} from "@minecraft/server-ui"
import { system, world } from "@minecraft/server"
import { getScore, hasTag, textTag, tellraw, rawtext, runcmd_at, scoreboard } from './AbstractTools.js'

export function actionsChain(chain,target) {
    let name = target.nameTag
    for (let i in chain) {
        let toValue = chain[i].value
        switch (chain[i].type) {
            case 'eval':
                eval(toValue)
                break
            case 'cmds':
                for (let j in toValue) {
                    runcmd_at(name,toValue[j])
                }
                break
            case 'say':
                rawtext(toValue,name)
                break
            case 'cmd':
                runcmd_at(name,toValue)
                break
            case 'form':
                openJSON(toValue,target)
                break
            case 'tellraw':
                tellraw(toValue,name)
                break
            case 'tellraw_sel':
                tellraw(toValue[1],toValue[0])
                break
        }
    }
}

export function openJSON(systemName,target) {
    system.run(() => {
        let name = target.nameTag
        let formData = FORMS[systemName]
        //JSON.stringify(formData)

        const formTale = new ActionFormData()
        formTale.title(formData.title)
        formTale.body(formData.body)

        let buttons = formData.buttons
        for (let i in buttons) {
            let thisButt = buttons[i]
            if (thisButt.icon != undefined || thisButt.icon != '') {
                formTale.button(thisButt.button_name,thisButt.icon)
            } else {
                formTale.button(thisButt.button_name)
            }
        }

        formTale.show(target).then(gg => {
            if (gg.selection != undefined) {
                actionsChain(buttons[gg.selection].on_click,target)
            } else if (formData.on_close != undefined) {
                actionsChain(formData.on_close,target)
            }
        })
    })
}